diff --git a/jerry-core/ecma/operations/ecma-typedarray-object.c b/jerry-core/ecma/operations/ecma-typedarray-object.c
index 660454875c..29ca06ce1a 100644
--- a/jerry-core/ecma/operations/ecma-typedarray-object.c
+++ b/jerry-core/ecma/operations/ecma-typedarray-object.c
@@ -26,6 +26,7 @@
 #include "ecma-gc.h"
 #include "ecma-globals.h"
 #include "ecma-helpers.h"
+#include "jcontext.h"
 
 #ifndef CONFIG_DISABLE_ES2015_TYPEDARRAY_BUILTIN
 
@@ -892,12 +893,14 @@ ecma_op_typedarray_set_index_prop (ecma_object_t *obj_p, /**< a TypedArray objec
 
   ECMA_OP_TO_NUMBER_FINALIZE (value_num);
 
-  if (ecma_is_value_empty (error))
+  if (ECMA_IS_VALUE_ERROR (error))
   {
-    return true;
+    ecma_free_value (JERRY_CONTEXT (error_value));
+    return false;
   }
 
-  return false;
+  JERRY_ASSERT (ecma_is_value_empty (error));
+  return true;
 } /* ecma_op_typedarray_set_index_prop */
 
 /**
diff --git a/tests/jerry/es2015/regression-test-issue-2143.js b/tests/jerry/es2015/regression-test-issue-2143.js
new file mode 100644
index 0000000000..01308d73eb
--- /dev/null
+++ b/tests/jerry/es2015/regression-test-issue-2143.js
@@ -0,0 +1,16 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+var a = new Uint8Array(2);
+a[0] = { valueOf : function() { throw "intoint"; } };
